﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;

namespace Custom_DataReader_Streaming
{
    class Program
    {
        private static string connectionString = "Data Source=GALACTICA\\SQLEXPRESS;Initial Catalog=Development;Integrated Security=SSPI;";
        static void Main(string[] args)
        {
            List<CustomObject> list = new List<CustomObject>();
            Random r = new Random();
            for (int i = 0; i < 10000; i++)
            {
                CustomObject t = new CustomObject();
                t.UniqueId = Guid.NewGuid();
                t.RandomNumber = r.Next();
                list.Add(t);
            }

            DateTime startDate = DateTime.Now;
            using (SqlConnection conn = new SqlConnection(connectionString))
            {
                conn.Open();
                using (SqlCommand cmd = new SqlCommand("INSERT INTO RandomNumbers VALUES (@UniqueId, @RandomNumber)", conn))
                {
                    cmd.Parameters.Add(new SqlParameter("@UniqueId", System.Data.SqlDbType.UniqueIdentifier));
                    cmd.Parameters.Add(new SqlParameter("@RandomNumber", System.Data.SqlDbType.Int));
                    for (int i = 0; i < list.Count; i++)
                    {
                        cmd.Parameters["@UniqueId"].Value = list[i].UniqueId;
                        cmd.Parameters["@RandomNumber"].Value = list[i].RandomNumber;
                        cmd.ExecuteNonQuery();
                    }
                }
            }
            double nonBulkCopy = DateTime.Now.Subtract(startDate).TotalSeconds;

            startDate = DateTime.Now;
            CustomObjectDataReader reader = new CustomObjectDataReader(list);
            using (SqlConnection conn = new SqlConnection(connectionString))
            {
                conn.Open();
                using (SqlBulkCopy cpy = new SqlBulkCopy(conn))
                {
                    cpy.DestinationTableName = "RandomNumbers";
                    cpy.WriteToServer(reader);
                }
            }
            double bulkCopy = DateTime.Now.Subtract(startDate).TotalSeconds;

            Console.WriteLine("Non-Bulk Copy: " + nonBulkCopy + " seconds");
            Console.WriteLine("Bulk Copy: " + bulkCopy + " seconds");
            Console.ReadLine();
        }
    }
}
